//+------------------------------------------------------------------+
//|                                           Find_pair_T101_v23.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|        T101:                        |
//|  -    ;                          |
//|  -        .       |
//|                                                                  |
//|  v11 -     .                 |
//|                                                                  |
//|  v2 -      .  |
//|        -    .               |
//|                                                                  |
//|  v21 -   ""   NZD.             |
//|                                                                  |
//|  v22 -     ( 28-)  .      |
//|                                                                  |
//|  v23 -      .   | 
//|  |
//|  |
//+------------------------------------------------------------------+
#property copyright "GrayMan77"
#property link      ""

#property indicator_chart_window

//----  
extern int CorrelationBars=1000; //     
extern int SymbolsPerGroup=7;    //   

//     
extern bool Use_EURUSD=true;
extern bool Use_GBPUSD=true;
extern bool Use_USDCHF=true;
extern bool Use_USDJPY=true;
extern bool Use_AUDUSD=true;
extern bool Use_USDCAD=true;
extern bool Use_NZDUSD=true;
extern bool Use_EURGBP=true;
extern bool Use_EURCHF=true;
extern bool Use_EURJPY=true;
extern bool Use_EURAUD=true;
extern bool Use_EURCAD=true;
extern bool Use_EURNZD=true;
extern bool Use_GBPCHF=true;
extern bool Use_GBPJPY=true;
extern bool Use_GBPAUD=true;
extern bool Use_GBPCAD=true;
extern bool Use_NZDGBP_or_GBPNZD=true;
extern bool Use_CHFJPY=true;
extern bool Use_AUDCHF=true;
extern bool Use_CADCHF=true;
extern bool Use_NZDCHF=true;
extern bool Use_AUDJPY=true;
extern bool Use_CADJPY=true;
extern bool Use_NZDJPY=true;
extern bool Use_AUDCAD=true;
extern bool Use_AUDNZD=true;
extern bool Use_NZDCAD=true;

//---- 

//   ( -  !!!)
string Symbols[]={"EURUSD","GBPUSD","USDCHF","USDJPY","AUDUSD","USDCAD",
               "NZDUSD","EURGBP","EURCHF","EURJPY","EURAUD","EURCAD",
               "EURNZD","GBPCHF","GBPJPY","GBPAUD","GBPCAD","NZDGBP",
               "CHFJPY","AUDCHF","CADCHF","NZDCHF","AUDJPY","CADJPY",
               "NZDJPY","AUDCAD","AUDNZD","NZDCAD"};
bool NotCalculate;
int startTime,fihishTime;
bool Error;

double Correlation[28][28];
double iCloseSymbols[][28];  //   (1-  - ; 2- -  
double BaseLots[28]; //   

int FindSymbols;
int NumbSymbGroup1[],NumbSymbGroup2[];
double StoreCorr[];

int F_Symb1[],F_Symb2[],F_Typ[]; //        
double F_Lots[];

double Equity[],Equity1[],Equity2[]; //  

bool Variants[][14]; //   ()
int VarTotal;  //  

//   
bool UseSymbol[28]={false,false,false,false,false,false,false,false,false,false,
                    false,false,false,false,false,false,false,false,false,false,
                    false,false,false,false,false,false,false,false};

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int i;
   
   Error=false;
   
   NotCalculate=true;
   
   //       
   ArrayResize(iCloseSymbols,CorrelationBars+1);
   ArrayResize(NumbSymbGroup1,SymbolsPerGroup);
   ArrayResize(NumbSymbGroup2,SymbolsPerGroup);
   ArrayResize(StoreCorr,SymbolsPerGroup);
   ArrayResize(F_Symb1,SymbolsPerGroup);
   ArrayResize(F_Symb2,SymbolsPerGroup);
   ArrayResize(F_Typ,SymbolsPerGroup);
   ArrayResize(F_Lots,SymbolsPerGroup);
   ArrayResize(Equity,CorrelationBars);
   ArrayResize(Equity1,CorrelationBars);
   ArrayResize(Equity2,CorrelationBars);
   
   VarTotal=MathPow(2.,SymbolsPerGroup);
   ArrayResize(Variants,VarTotal);
   
   //      
   for(i=0;i<SymbolsPerGroup;i++)
     {
     F_Lots[i]=0.1;
     F_Typ[i]=1;
     }
   
   //      
   //     
   for(i=0; i<28; i++)
     {
     BaseLots[i]=MarketInfo(Symbols[i],MODE_LOTSIZE);
     //Print("BaseLots[",i,"]=",BaseLots[i]);
     if(MarketInfo(Symbols[i],MODE_TRADEALLOWED)==1) UseSymbol[i]=true;
     }
   if(MarketInfo("GBPNZD",MODE_TRADEALLOWED)==1)
    {
    UseSymbol[17]=true;
    Symbols[17]="GBPNZD";
    }
   
   //    
   if(!Use_EURUSD) UseSymbol[0]=false;
   if(!Use_GBPUSD) UseSymbol[1]=false;
   if(!Use_USDCHF) UseSymbol[2]=false;
   if(!Use_USDJPY) UseSymbol[3]=false;
   if(!Use_AUDUSD) UseSymbol[4]=false;
   if(!Use_USDCAD) UseSymbol[5]=false;
   if(!Use_NZDUSD) UseSymbol[6]=false;
   if(!Use_EURGBP) UseSymbol[7]=false;
   if(!Use_EURCHF) UseSymbol[8]=false;
   if(!Use_EURJPY) UseSymbol[9]=false;
   if(!Use_EURAUD) UseSymbol[10]=false;
   if(!Use_EURCAD) UseSymbol[11]=false;
   if(!Use_EURNZD) UseSymbol[12]=false;
   if(!Use_GBPCHF) UseSymbol[13]=false;
   if(!Use_GBPJPY) UseSymbol[14]=false;
   if(!Use_GBPAUD) UseSymbol[15]=false;
   if(!Use_GBPCAD) UseSymbol[16]=false;
   if(!Use_NZDGBP_or_GBPNZD) UseSymbol[17]=false;
   if(!Use_CHFJPY) UseSymbol[18]=false;
   if(!Use_AUDCHF) UseSymbol[19]=false;
   if(!Use_CADCHF) UseSymbol[20]=false;
   if(!Use_NZDCHF) UseSymbol[21]=false;
   if(!Use_AUDJPY) UseSymbol[22]=false;
   if(!Use_CADJPY) UseSymbol[23]=false;
   if(!Use_NZDJPY) UseSymbol[24]=false;
   if(!Use_AUDCAD) UseSymbol[25]=false;
   if(!Use_AUDNZD) UseSymbol[26]=false;
   if(!Use_NZDCAD) UseSymbol[27]=false;
   
//----
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
  
  int i,j,k,razr;
  double CorrMax,Corr;
  int Store_i,Store_j;
  string str1,str2,str3;
  int NumberVar;
  
  
  //  
  if(Error || SymbolsPerGroup>14)
    {
    Print("   !");
    Alert("   !");
    return(-1);
    }
  
//----
  
  //   1 
  if(NotCalculate)
    {
    startTime=GetTickCount();
    
    // 
    ReadClose();
    
    //    (  )
    for(i=0;i<28;i++)
      {
      for(j=i+1;j<28;j++)
        {
        Correlation[i][j]=CorrTwoSymbols(i,j);
        }
      }
    
    //     
    FindSymbols=0.;
    while(FindSymbols<=SymbolsPerGroup)
      {
      CorrMax=-2.;
      for(i=0;i<27;i++)
        {
        for(j=i+1;j<28;j++)
          {
          if(Correlation[i][j]==-2.) continue;
          if(Correlation[i][j]>CorrMax)
            {
            CorrMax=Correlation[i][j];
            Store_i=i;
            Store_j=j;
            }
          }
        }
      NumbSymbGroup1[FindSymbols]=Store_i;
      NumbSymbGroup2[FindSymbols]=Store_j;
      StoreCorr[FindSymbols]=CorrMax;
      // ""       
      
      if(Store_i<27) { for(j=Store_i+1;j<28;j++) Correlation[Store_i][j]=-2.; }
      if(Store_j<27) { for(j=Store_j+1;j<28;j++) Correlation[Store_j][j]=-2.; }
      if(Store_j>0) { for(i=0;i<Store_j;i++) Correlation[i][Store_j]=-2.; }
      if(Store_i>0) { for(i=0;i<Store_i;i++) Correlation[i][Store_i]=-2.; }
      
      FindSymbols++;
      }
    
    //    
    //   
    //    
    for(j=0;j<SymbolsPerGroup;j++) Variants[0][j]=false;
    //    
    i=1; //   
    razr=0; //  
    while(razr<SymbolsPerGroup)
      {
      for(k=0;k<=i-1;k++)  //   
        {
        for(j=0;j<SymbolsPerGroup;j++) //    
          {
          Variants[i+k][j]=Variants[k][j];
          }
        Variants[i+k][razr]=true;
        }
      i=i*2;
      razr++;
      }
    
    //    
    CorrMax=-2.;
    NumberVar=-1;
    for(i=0;i<VarTotal;i++) //    
      {
      //        
      for(j=0;j<SymbolsPerGroup;j++) //    
        {
        if(Variants[i][j])
          {
          //   
          F_Symb1[j]=NumbSymbGroup2[j];
          F_Symb2[j]=NumbSymbGroup1[j];
          }
         else
          {
          //   
          F_Symb1[j]=NumbSymbGroup1[j];
          F_Symb2[j]=NumbSymbGroup2[j];
          }
        }
      //    
      EquityCalculate(F_Symb1);
      //    
      for(j=0;j<CorrelationBars;j++) Equity1[j]=Equity[j];
      EquityCalculate(F_Symb2);
      //    
      for(j=0;j<CorrelationBars;j++) Equity2[j]=Equity[j];
      //   
      Corr=CorrEquity();
      if(Corr>CorrMax)
        {
        CorrMax=Corr;
        NumberVar=i;
        }
      }
    
    //     
    for(j=0;j<SymbolsPerGroup;j++) //    
      {
      if(Variants[NumberVar][j])
        {
        //   
        F_Symb1[j]=NumbSymbGroup2[j];
        F_Symb2[j]=NumbSymbGroup1[j];
        }
       else
        {
        //   
        F_Symb1[j]=NumbSymbGroup1[j];
        F_Symb2[j]=NumbSymbGroup2[j];
        }
      }
    
    
    
    //  
    str1="\n     101     v23 \n (C) GrayMan77 \n \n       1           2           \n";
    str2="----";
    str3="----";
    for(i=0; i<SymbolsPerGroup; i++)
      {
      str1=str1+" \n    "+Symbols[F_Symb1[i]]+"           "+Symbols[F_Symb2[i]]+"           "+DoubleToStr(StoreCorr[i],4);
      str2=str2+Symbols[F_Symb1[i]]+";";
      str3=str3+Symbols[F_Symb2[i]]+";";
      }
    
    Comment(str1);
    
    //   
    Print(str2);
    Print(str3);
    
    NotCalculate=false;

    //   
    fihishTime=GetTickCount();
    Print("  ",(fihishTime-startTime)/1000.," .");
    }
   
//----
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    iCloseSymbols[][]  Close[]          |
//|   28-    CorrelationBars          |
//+------------------------------------------------------------------+
void ReadClose()
  {
  int i,j;
  datetime TimeBar;
  
  //   
  for(i=0; i<28; i++)
    {
    //   
    for(j=0; j<CorrelationBars; j++) // 0-   !!!
      {
      TimeBar=Time[j+1];
      iCloseSymbols[j][i]=iClose(Symbols[i],Period(),iBarShift(Symbols[i],Period(),TimeBar,false));
      }
    //   ()    Open 
    TimeBar=Time[CorrelationBars+1];
    iCloseSymbols[CorrelationBars][i]=iOpen(Symbols[i],Period(),iBarShift(Symbols[i],Period(),TimeBar,false));
    }
  /*
  for(i=0; i<28; i++)
    {
    Print("!!!!! ---- i=",i,"   Symbol=",Symbols[i],"    iCloseSymbols=",iCloseSymbols[0][i]);
    }
  */
  return;
  }
//+------------------------------------------------------



//+----------------------------------------------------------------------------+
//|                                                                |
//|       F_Symb[],F_Typ[],F_Lots[]             |
//|                                                         nSymb;     |
//|      Equity[]  CorrelationBars;         |
//|     iCloseSymbols[][] CorrelationBars FindSymbols|
//+----------------------------------------------------------------------------+
void EquityCalculate(int F_Symb[])
  {
  double res, sum, k2, l_bl;
  double ProfitBaseVal; //    
  double ProfitUSD;
  int i,j;
  string BaseVal;
  
  //   
  for(j=0; j<CorrelationBars; j++)
    {
    //   
    sum=0.;
    for(i=0; i<SymbolsPerGroup; i++)
      {
      if(F_Typ[i]==0)  // buy
        {
        k2=iCloseSymbols[j][F_Symb[i]];
        ProfitBaseVal=F_Lots[i]*BaseLots[F_Symb[i]]*(k2-iCloseSymbols[CorrelationBars][F_Symb[i]])/k2;
        }
      else
        {
        l_bl=F_Lots[i]*BaseLots[F_Symb[i]];
        ProfitBaseVal=l_bl*iCloseSymbols[CorrelationBars][F_Symb[i]]/iCloseSymbols[j][F_Symb[i]]-l_bl;
        }
      //    USD
      BaseVal=StringSubstr(Symbols[F_Symb[i]],0,3);
      if(BaseVal=="USD") ProfitUSD=ProfitBaseVal;
      if(BaseVal=="EUR") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][0];  // 0 - EURUSD
      if(BaseVal=="GBP") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][1];  // 1 - GBPUSD
      if(BaseVal=="AUD") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][4];  // 4 - AUDUSD
      if(BaseVal=="NZD") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][6];  // 6 - NZDUSD
      if(BaseVal=="CHF") ProfitUSD=ProfitBaseVal/iCloseSymbols[j][2];  // 2 - USDCHF
      if(BaseVal=="CAD") ProfitUSD=ProfitBaseVal/iCloseSymbols[j][5];  // 5 - USDCAD
      
      //  
      sum=sum+ProfitUSD;
      }
    Equity[j]=sum;
    }
  return;
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                       |
//|  Symbol1  Symbol2.                                              |
//|      iCloseSymbols[][28].                     |
//|      - CorrelationBars.                 |
//+------------------------------------------------------------------+
double CorrTwoSymbols(int Symbol1,int Symbol2)
  {
  double res;
  int i;
  double Average1=0.,Average2=0.;
  double Delta1,Delta2,sumD1D2=0.,sumD1_2=0.,sumD2_2=0.;
  
  //     - 
  if(!UseSymbol[Symbol1] || !UseSymbol[Symbol2]) return(-2.);
  
  //   
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Average1=Average1+iCloseSymbols[i][Symbol1];
    Average2=Average2+iCloseSymbols[i][Symbol2];
    }
  Average1=Average1/CorrelationBars;
  Average2=Average2/CorrelationBars;
  
  //  
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Delta1=iCloseSymbols[i][Symbol1]-Average1;
    Delta2=iCloseSymbols[i][Symbol2]-Average2;
    sumD1D2=sumD1D2+Delta1*Delta2;
    sumD1_2=sumD1_2+Delta1*Delta1;
    sumD2_2=sumD2_2+Delta2*Delta2;
    }
  
  //   
  res=sumD1D2/MathSqrt(sumD1_2*sumD2_2);
  
  return(res);
  }

//---------------------------------------------------------------------------

//+------------------------------------------------------------------+
//|       (.):     |
//|  Equity1[]  Equity2[].                                          |
//+------------------------------------------------------------------+
double CorrEquity()
  {
  double res;
  int i;
  double Average1=0.,Average2=0.;
  double Delta1,Delta2,sumD1D2=0.,sumD1_2=0.,sumD2_2=0.;
  
  //    
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Average1=Average1+Equity1[i];
    Average2=Average2+Equity2[i];
    }
  Average1=Average1/CorrelationBars;
  Average2=Average2/CorrelationBars;
  
  //  
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Delta1=Equity1[i]-Average1;
    Delta2=Equity2[i]-Average2;
    sumD1D2=sumD1D2+Delta1*Delta2;
    sumD1_2=sumD1_2+Delta1*Delta1;
    sumD2_2=sumD2_2+Delta2*Delta2;
    }
  
  //   
  res=sumD1D2/MathSqrt(sumD1_2*sumD2_2);
  
  return(res);
  }

//---------------------------------------------------------------------------